import { TransactionalAdapter } from '@nestjs-cls/transactional';
import { ClientSession, ClientSessionOptions, MongoClient, TransactionOptions } from 'mongodb';
export type MongoDBTransactionOptions = TransactionOptions & {
    /**
     * Options for the encompassing `session` that hosts the transaction.
     */
    sessionOptions?: ClientSessionOptions;
};
export interface MongoDBTransactionalAdapterOptions {
    /**
     * The injection token for the MongoClient instance.
     */
    mongoClientToken: any;
    /**
     * Default options for the transaction. These will be merged with any transaction-specific options
     * passed to the `@Transactional` decorator or the `TransactionHost#withTransaction` method.
     */
    defaultTxOptions?: Partial<MongoDBTransactionOptions>;
}
export declare class TransactionalAdapterMongoDB implements TransactionalAdapter<MongoClient, ClientSession | undefined, MongoDBTransactionOptions> {
    connectionToken: any;
    defaultTxOptions?: Partial<TransactionOptions>;
    constructor(options: MongoDBTransactionalAdapterOptions);
    /** cannot proxy an `undefined` value */
    supportsTransactionProxy: boolean;
    optionsFactory(mongoClient: MongoClient): {
        wrapWithTransaction: (options: MongoDBTransactionOptions, fn: (...args: any[]) => Promise<any>, setTx: (tx?: ClientSession) => void) => Promise<any>;
        getFallbackInstance: () => undefined;
    };
}
//# sourceMappingURL=transactional-adapter-mongodb.d.ts.map